searchData={"items":[{"type":"module","title":"Ravix","doc":"Ravix is a RavenDB Driver written in Elixir","ref":"Ravix.html"},{"type":"function","title":"Ravix.start/2","doc":"Initializes three processes registers to facilitate grouping sessions, connections and nodes.\n  - :sessions = Stores sessions by their UUIDs\n  - :connections = Stores the connections processes, based on the Repo Name\n  - :request_executors = Stores the node executors data","ref":"Ravix.html#start/2"},{"type":"module","title":"Ravix.Connection.Commands.GetTopology","doc":"Command to fetch the topology data from RavenDB","ref":"Ravix.Connection.Commands.GetTopology.html"},{"type":"module","title":"Fields - Ravix.Connection.Commands.GetTopology","doc":"- database_name: The name of the database\n- force_url: Forces the informed url to the new topology","ref":"Ravix.Connection.Commands.GetTopology.html#module-fields"},{"type":"type","title":"Ravix.Connection.Commands.GetTopology.t/0","doc":"","ref":"Ravix.Connection.Commands.GetTopology.html#t:t/0"},{"type":"module","title":"Ravix.Connection.Executor.RavenResponse","doc":"Struct to represent a response from RavenDB","ref":"Ravix.Connection.Executor.RavenResponse.html"},{"type":"function","title":"Ravix.Connection.Executor.RavenResponse.response_etag/1","doc":"","ref":"Ravix.Connection.Executor.RavenResponse.html#response_etag/1"},{"type":"type","title":"Ravix.Connection.Executor.RavenResponse.t/0","doc":"","ref":"Ravix.Connection.Executor.RavenResponse.html#t:t/0"},{"type":"module","title":"Ravix.Connection.Response","doc":"Represents the response of a RavenDB API call","ref":"Ravix.Connection.Response.html"},{"type":"type","title":"Ravix.Connection.Response.t/0","doc":"","ref":"Ravix.Connection.Response.html#t:t/0"},{"type":"module","title":"Ravix.Connection.ServerNode","doc":"State of a RavenDB connection executor node\n\n    - store: Atom of the RavenDB Store, E.g: Ravix.Test.Store\n    - url: URL of this node\n    - port: port of this node\n    - conn: TCP Connection State\n    - protocol: http or https\n    - database: For which database is this executor\n    - cluster_tag: Tag of this node in the RavenDB cluster\n    - settings: General node settings","ref":"Ravix.Connection.ServerNode.html"},{"type":"function","title":"Ravix.Connection.ServerNode.bootstrap/1","doc":"","ref":"Ravix.Connection.ServerNode.html#bootstrap/1"},{"type":"function","title":"Ravix.Connection.ServerNode.from_api_response/2","doc":"","ref":"Ravix.Connection.ServerNode.html#from_api_response/2"},{"type":"function","title":"Ravix.Connection.ServerNode.node_database_path/1","doc":"Helper method to build the base path for Database specific API requests","ref":"Ravix.Connection.ServerNode.html#node_database_path/1"},{"type":"function","title":"Ravix.Connection.ServerNode.node_id/1","doc":"","ref":"Ravix.Connection.ServerNode.html#node_id/1"},{"type":"function","title":"Ravix.Connection.ServerNode.node_url/1","doc":"Node host and port","ref":"Ravix.Connection.ServerNode.html#node_url/1"},{"type":"type","title":"Ravix.Connection.ServerNode.t/0","doc":"","ref":"Ravix.Connection.ServerNode.html#t:t/0"},{"type":"module","title":"Ravix.Connection.ServerNode.Settings","doc":"- http_client_name: Name of the Finch http client to use with this node,","ref":"Ravix.Connection.ServerNode.Settings.html"},{"type":"function","title":"Ravix.Connection.ServerNode.Settings.build/1","doc":"","ref":"Ravix.Connection.ServerNode.Settings.html#build/1"},{"type":"type","title":"Ravix.Connection.ServerNode.Settings.t/0","doc":"","ref":"Ravix.Connection.ServerNode.Settings.html#t:t/0"},{"type":"module","title":"Ravix.Connection.State","doc":"Represents the state of a RavenDB connection\n\n   - store: Store atom for this state. E.g: Ravix.Test.Store\n   - database: Name of the database.\n   - conventions: Document Configuration conventions\n   - retry_on_failure: Automatic retry in retryable errors\n   - retry_on_stale: Automatic retry when the query is stale\n   - retry_backoff: Amount of time between retries (in ms)\n   - retry_count: Amount of retries\n   - http_client_name: The name of the http client that will be used by this store\n   - node_selector: Module that selects the nodes based on different strategies. E.g: Ravix.Connection.NodeSelector\n   - urls: List of the urls of RavenDB servers\n   - topology_etag: ETAG of the RavenDB cluster topology\n   - disable_topology_updates: If true, the topology will not be updated automatically when requested by the ravendb server\n   - force_create_database: If true, when the database does not exist, it will be created\n   - last_topology_update: DateTime when the topology was last updated\n   - cluster_token: Security Token for the members of the cluster","ref":"Ravix.Connection.State.html"},{"type":"type","title":"Ravix.Connection.State.t/0","doc":"","ref":"Ravix.Connection.State.html#t:t/0"},{"type":"module","title":"Ravix.Connection.Topology","doc":"Represents the RavenDB topology\n\n    - etag: Topology etag\n    - nodes: List of ServerNodes for this topology","ref":"Ravix.Connection.Topology.html"},{"type":"function","title":"Ravix.Connection.Topology.cluster_tag_for_node/2","doc":"Fetches the cluster_tag for the informed node","ref":"Ravix.Connection.Topology.html#cluster_tag_for_node/2"},{"type":"type","title":"Ravix.Connection.Topology.t/0","doc":"","ref":"Ravix.Connection.Topology.html#t:t/0"},{"type":"module","title":"Ravix.Document","doc":"Macro to facilitate the representation of a Raven Document","ref":"Ravix.Document.html"},{"type":"module","title":"Example - Ravix.Document","doc":"`defmodule Ravix.TestDocument do\n       use Ravix.Document, fields: [\n         name: nil,\n         id: nil\n       ]\n     end`","ref":"Ravix.Document.html#module-example"},{"type":"macro","title":"Ravix.Document.compile_configs/1","doc":"","ref":"Ravix.Document.html#compile_configs/1"},{"type":"module","title":"Ravix.Documents.Caching","doc":"","ref":"Ravix.Documents.Caching.html"},{"type":"module","title":"Fields - Ravix.Documents.Caching","doc":"- use_agressive_cache: Sends the 'If-None-Match' headers on query, if the result is cached locally and did not change, the query will return a 304 and not the actual results\n- cache_duration: How long should the cache be kept on the client side (in seconds)\n- cache: The nebulex cache module to use","ref":"Ravix.Documents.Caching.html#module-fields"},{"type":"type","title":"Ravix.Documents.Caching.t/0","doc":"","ref":"Ravix.Documents.Caching.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Commands.BatchCommand","doc":"Raven Command to execute actions in batches","ref":"Ravix.Documents.Commands.BatchCommand.html"},{"type":"module","title":"Fields - Ravix.Documents.Commands.BatchCommand","doc":"- Commands: list of raven commands to be executed","ref":"Ravix.Documents.Commands.BatchCommand.html#module-fields"},{"type":"function","title":"Ravix.Documents.Commands.BatchCommand.parse_batch_response/2","doc":"Parses the response of a batch request","ref":"Ravix.Documents.Commands.BatchCommand.html#parse_batch_response/2"},{"type":"function","title":"Parameters - Ravix.Documents.Commands.BatchCommand.parse_batch_response/2","doc":"- batch_response: The RavenDB batch response. \n- session_state: The state of the session where the command was executed.","ref":"Ravix.Documents.Commands.BatchCommand.html#parse_batch_response/2-parameters"},{"type":"type","title":"Ravix.Documents.Commands.BatchCommand.t/0","doc":"","ref":"Ravix.Documents.Commands.BatchCommand.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Commands.ExecuteQueryCommand","doc":"Command to execute a queryy on RavenDB","ref":"Ravix.Documents.Commands.ExecuteQueryCommand.html"},{"type":"module","title":"Fields - Ravix.Documents.Commands.ExecuteQueryCommand","doc":"- Query: the RQL to be executed\n- QueryParameters: The query parameters","ref":"Ravix.Documents.Commands.ExecuteQueryCommand.html#module-fields"},{"type":"function","title":"Ravix.Documents.Commands.ExecuteQueryCommand.hash_query/1","doc":"","ref":"Ravix.Documents.Commands.ExecuteQueryCommand.html#hash_query/1"},{"type":"type","title":"Ravix.Documents.Commands.ExecuteQueryCommand.t/0","doc":"","ref":"Ravix.Documents.Commands.ExecuteQueryCommand.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Commands.ExecuteStreamQueryCommand","doc":"Command to execute a query on RavenDB","ref":"Ravix.Documents.Commands.ExecuteStreamQueryCommand.html"},{"type":"module","title":"Fields - Ravix.Documents.Commands.ExecuteStreamQueryCommand","doc":"- Query: the RQL to be executed\n- QueryParameters: The query parameters","ref":"Ravix.Documents.Commands.ExecuteStreamQueryCommand.html#module-fields"},{"type":"type","title":"Ravix.Documents.Commands.ExecuteStreamQueryCommand.t/0","doc":"","ref":"Ravix.Documents.Commands.ExecuteStreamQueryCommand.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Commands.GetDocumentsCommand","doc":"Command to fetch documents from RavenDB","ref":"Ravix.Documents.Commands.GetDocumentsCommand.html"},{"type":"module","title":"Fields - Ravix.Documents.Commands.GetDocumentsCommand","doc":"- ids: List of document ids\n- includes: Path of the referenced documents that should be included\n- metadata_only: If the response should contain only the metadata\n- start: from which position should the returned documents start\n- page_size: number of documents that should be returned\n- counter_includes: List of counters to be returned","ref":"Ravix.Documents.Commands.GetDocumentsCommand.html#module-fields"},{"type":"function","title":"Ravix.Documents.Commands.GetDocumentsCommand.parse_response/2","doc":"Parses the response of the GetCommand","ref":"Ravix.Documents.Commands.GetDocumentsCommand.html#parse_response/2"},{"type":"function","title":"Parameters - Ravix.Documents.Commands.GetDocumentsCommand.parse_response/2","doc":"- session_state: The session state where this command was called\n- documents_response: Response from the database call","ref":"Ravix.Documents.Commands.GetDocumentsCommand.html#parse_response/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Commands.GetDocumentsCommand.parse_response/2","doc":"- List of results and includes","ref":"Ravix.Documents.Commands.GetDocumentsCommand.html#parse_response/2-returns"},{"type":"type","title":"Ravix.Documents.Commands.GetDocumentsCommand.t/0","doc":"","ref":"Ravix.Documents.Commands.GetDocumentsCommand.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Commands.RavenCommand","doc":"Macro to define the basic required fields for a RavenCommand","ref":"Ravix.Documents.Commands.RavenCommand.html"},{"type":"module","title":"Fields - Ravix.Documents.Commands.RavenCommand","doc":"- url: Where the command will be executed\n- method: HTTP Method\n- data: The json body payload\n- headers: HTTP headers to send to Raven\n- is_stream: If the request should be streamed\n- is_read_request: If this request is read_only","ref":"Ravix.Documents.Commands.RavenCommand.html#module-fields"},{"type":"macro","title":"Ravix.Documents.Commands.RavenCommand.command_type/1","doc":"","ref":"Ravix.Documents.Commands.RavenCommand.html#command_type/1"},{"type":"module","title":"Ravix.Documents.Conventions","doc":"Document conventions structure","ref":"Ravix.Documents.Conventions.html"},{"type":"module","title":"Fields - Ravix.Documents.Conventions","doc":"- max_number_of_requests_per_session: How many requests can be done in a single session\n- max_ids_to_catch: Maximum amount of ids that can be loaded\n- timeout: How much time until an api call times out\n- use_optimistic_concurrency: If optimistic concurrency should be used\n- caching: Configures query caching\n- max_length_of_query_using_get_url: Maximum length of an api call url\n- session_idle_ttl: How much time a session can live without interaction\n- disable_topology_update: if true, no automatic topology updates will be executed\n- not_allow_stale_indexes: List of indexes that can't have stale reads","ref":"Ravix.Documents.Conventions.html#module-fields"},{"type":"type","title":"Ravix.Documents.Conventions.t/0","doc":"","ref":"Ravix.Documents.Conventions.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Metadata","doc":"Functions related to document metadata management","ref":"Ravix.Documents.Metadata.html"},{"type":"function","title":"Ravix.Documents.Metadata.add_metadata/2","doc":"Adds the metadata to the entity","ref":"Ravix.Documents.Metadata.html#add_metadata/2"},{"type":"function","title":"Ravix.Documents.Metadata.build_default_metadata/1","doc":"Builds the metadata for the informed document","ref":"Ravix.Documents.Metadata.html#build_default_metadata/1"},{"type":"module","title":"Ravix.Documents.Session","doc":"A stateful session to execute RavenDB commands","ref":"Ravix.Documents.Session.html"},{"type":"function","title":"Ravix.Documents.Session.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Ravix.Documents.Session.html#child_spec/1"},{"type":"function","title":"Ravix.Documents.Session.delete/2","doc":"Marks the document for deletion","ref":"Ravix.Documents.Session.html#delete/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.delete/2","doc":"- session_id: the session id\n- entity/entity_id: the document to be deleted","ref":"Ravix.Documents.Session.html#delete/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.delete/2","doc":"- `{:ok, Ravix.Documents.Session.State}`\n- `{:error, cause}`","ref":"Ravix.Documents.Session.html#delete/2-returns"},{"type":"function","title":"Ravix.Documents.Session.execute_query/3","doc":"Executes a query into the RavenDB","ref":"Ravix.Documents.Session.html#execute_query/3"},{"type":"function","title":"Parameters - Ravix.Documents.Session.execute_query/3","doc":"- query: The `Ravix.RQL.Query` to be executed\n- session_id: the session_id\n- method: The http method\n\nReturns a RavenDB query response","ref":"Ravix.Documents.Session.html#execute_query/3-parameters"},{"type":"function","title":"Ravix.Documents.Session.fetch_state/1","doc":"Fetches the current session state\n\nReturns a `{:ok, Ravix.Documents.Session.State}`","ref":"Ravix.Documents.Session.html#fetch_state/1"},{"type":"function","title":"Ravix.Documents.Session.handle_continue/2","doc":"","ref":"Ravix.Documents.Session.html#handle_continue/2"},{"type":"function","title":"Ravix.Documents.Session.init/1","doc":"","ref":"Ravix.Documents.Session.html#init/1"},{"type":"function","title":"Ravix.Documents.Session.load/4","doc":"Loads the document from the database to the local session","ref":"Ravix.Documents.Session.html#load/4"},{"type":"function","title":"Parameters - Ravix.Documents.Session.load/4","doc":"- session_id: the session_id\n- ids: the document ids to be loaded\n- includes: the document includes path\n- opts: load options","ref":"Ravix.Documents.Session.html#load/4-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.load/4","doc":"- `{:ok, results}`\n- `{:errors, cause}`","ref":"Ravix.Documents.Session.html#load/4-returns"},{"type":"function","title":"Examples - Ravix.Documents.Session.load/4","doc":"iex> Session.load(session_id, \"entity_id\")\n        {:ok,\n        %{\n          \"Includes\" => %{},\n          \"Results\" => [\n            %{\n              \"@metadata\" => %{\n                \"@change-vector\" => \"A:6450-HJrwf2z3c0G/FHJPm3zK3w\",\n                \"@id\" => \"f13ffb17-ed7d-43b6-a483-23993db70958\",\n                \"@last-modified\" => \"2022-04-23T11:14:16.4277047Z\"\n              },\n              \"cat_name\" => \"Coco\",\n              \"id\" => \"f13ffb17-ed7d-43b6-a483-23993db70958\"\n            }\n          ],\n          \"already_loaded_ids\" => []\n        }}","ref":"Ravix.Documents.Session.html#load/4-examples"},{"type":"function","title":"Ravix.Documents.Session.save_changes/1","doc":"Persists the session changes to the RavenDB database\n\nReturns a [RavenDB batch response](https://ravendb.net/docs/article-page/5.3/csharp/client-api/rest-api/document-commands/batch-commands#response-format)","ref":"Ravix.Documents.Session.html#save_changes/1"},{"type":"function","title":"Examples - Ravix.Documents.Session.save_changes/1","doc":"iex> Session.save_changes(session_id)\n        {:ok,\n        %{\n          \"Results\" => [\n            %{\n              \"ChangeVector\" => nil,\n              \"Deleted\" => true,\n              \"Id\" => \"3421125e-416a-4bce-bb56-56cb4a7991ae\",\n              \"Type\" => \"DELETE\"\n            }\n          ]\n        }}","ref":"Ravix.Documents.Session.html#save_changes/1-examples"},{"type":"function","title":"Ravix.Documents.Session.start_link/1","doc":"","ref":"Ravix.Documents.Session.html#start_link/1"},{"type":"function","title":"Ravix.Documents.Session.store/5","doc":"Add a document to the session to be created","ref":"Ravix.Documents.Session.html#store/5"},{"type":"function","title":"Parameters - Ravix.Documents.Session.store/5","doc":"- session_id: the session id\n- entity: the document to store\n- key: the document key to be used\n- change_vector: the concurrency change vector\n- opts: [\n  upsert: If the document is already loaded in the session, it should be upserted\n]","ref":"Ravix.Documents.Session.html#store/5-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.store/5","doc":"- `{:ok, Ravix.Documents.Session.State}`\n- `{:error, cause}`","ref":"Ravix.Documents.Session.html#store/5-returns"},{"type":"function","title":"Ravix.Documents.Session.stream_query/2","doc":"Executes a query in RavenDB and stream the response","ref":"Ravix.Documents.Session.html#stream_query/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.stream_query/2","doc":"- query: The `Ravix.RQL.Query` to be executed\n- session_id: the session_id\n\nReturns a enumerable with the \"Results\" field of the RavenDB Query Response","ref":"Ravix.Documents.Session.html#stream_query/2-parameters"},{"type":"module","title":"Ravix.Documents.Session.Manager","doc":"Functions to manage session changes","ref":"Ravix.Documents.Session.Manager.html"},{"type":"function","title":"Ravix.Documents.Session.Manager.delete_document/2","doc":"","ref":"Ravix.Documents.Session.Manager.html#delete_document/2"},{"type":"function","title":"Ravix.Documents.Session.Manager.execute_query/3","doc":"","ref":"Ravix.Documents.Session.Manager.html#execute_query/3"},{"type":"function","title":"Ravix.Documents.Session.Manager.load_documents/4","doc":"","ref":"Ravix.Documents.Session.Manager.html#load_documents/4"},{"type":"function","title":"Ravix.Documents.Session.Manager.save_changes/1","doc":"","ref":"Ravix.Documents.Session.Manager.html#save_changes/1"},{"type":"function","title":"Ravix.Documents.Session.Manager.store_entity/5","doc":"","ref":"Ravix.Documents.Session.Manager.html#store_entity/5"},{"type":"function","title":"Ravix.Documents.Session.Manager.stream_query/3","doc":"","ref":"Ravix.Documents.Session.Manager.html#stream_query/3"},{"type":"module","title":"Ravix.Documents.Session.SaveChangesData","doc":"Defines all changes that will be executed in a session when calling the save_changes function","ref":"Ravix.Documents.Session.SaveChangesData.html"},{"type":"module","title":"Fields - Ravix.Documents.Session.SaveChangesData","doc":"- deferred_commands_count: How many command will be executed\n- commands: List of commands to be executed\n- entities: Entities in the current session","ref":"Ravix.Documents.Session.SaveChangesData.html#module-fields"},{"type":"function","title":"Ravix.Documents.Session.SaveChangesData.add_deferred_commands/2","doc":"Add the commands that will be deferred to be executed together with the save_changes call","ref":"Ravix.Documents.Session.SaveChangesData.html#add_deferred_commands/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.SaveChangesData.add_deferred_commands/2","doc":"- save_changes_data: this structure instance\n- deferred_commands: Raven commands to be deferred","ref":"Ravix.Documents.Session.SaveChangesData.html#add_deferred_commands/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.SaveChangesData.add_deferred_commands/2","doc":"- Updated `Ravix.Documents.Session.SaveChangesData`","ref":"Ravix.Documents.Session.SaveChangesData.html#add_deferred_commands/2-returns"},{"type":"function","title":"Ravix.Documents.Session.SaveChangesData.add_delete_commands/2","doc":"Add the entities that will be deleted","ref":"Ravix.Documents.Session.SaveChangesData.html#add_delete_commands/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.SaveChangesData.add_delete_commands/2","doc":"- save_changes_data: this structure instance\n- deleted_entities: Entities that will be deleted","ref":"Ravix.Documents.Session.SaveChangesData.html#add_delete_commands/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.SaveChangesData.add_delete_commands/2","doc":"- Updated `Ravix.Documents.Session.SaveChangesData`","ref":"Ravix.Documents.Session.SaveChangesData.html#add_delete_commands/2-returns"},{"type":"function","title":"Ravix.Documents.Session.SaveChangesData.add_put_commands/2","doc":"Adds the documents that will be created","ref":"Ravix.Documents.Session.SaveChangesData.html#add_put_commands/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.SaveChangesData.add_put_commands/2","doc":"- save_changes_data: this structure instance\n- documents_by_id: Map with the documents that will be created","ref":"Ravix.Documents.Session.SaveChangesData.html#add_put_commands/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.SaveChangesData.add_put_commands/2","doc":"- Updated `Ravix.Documents.Session.SaveChangesData`","ref":"Ravix.Documents.Session.SaveChangesData.html#add_put_commands/2-returns"},{"type":"type","title":"Ravix.Documents.Session.SaveChangesData.t/0","doc":"","ref":"Ravix.Documents.Session.SaveChangesData.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Session.SessionDocument","doc":"Representation of a document inside the Store Session","ref":"Ravix.Documents.Session.SessionDocument.html"},{"type":"module","title":"Fields - Ravix.Documents.Session.SessionDocument","doc":"- entity: The document itself\n- key: The document key identity\n- original_value: the document value as it is in the database\n- change_vector: The change_vector string to deal with cluster concurrency","ref":"Ravix.Documents.Session.SessionDocument.html#module-fields"},{"type":"function","title":"Ravix.Documents.Session.SessionDocument.upsert_document/2","doc":"Upserts a document in the informed session state","ref":"Ravix.Documents.Session.SessionDocument.html#upsert_document/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.SessionDocument.upsert_document/2","doc":"- session_state: the session to be updated\n- document: the document to be upserted","ref":"Ravix.Documents.Session.SessionDocument.html#upsert_document/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.SessionDocument.upsert_document/2","doc":"- `{:error, :document_is_null}` if the document is not informed\n- `Ravix.Documents.Session.SessionDocument` if the session was updated correctly","ref":"Ravix.Documents.Session.SessionDocument.html#upsert_document/2-returns"},{"type":"function","title":"Ravix.Documents.Session.SessionDocument.upsert_document/3","doc":"Upserts a document in the informed session state","ref":"Ravix.Documents.Session.SessionDocument.html#upsert_document/3"},{"type":"function","title":"Parameters - Ravix.Documents.Session.SessionDocument.upsert_document/3","doc":"- session_state: the session to be updated\n- document_id: the key of the document to be upserted\n- metadata: The metadata of the document","ref":"Ravix.Documents.Session.SessionDocument.html#upsert_document/3-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.SessionDocument.upsert_document/3","doc":"- `{:error, :document_is_null}` if the document is not informed\n- `Ravix.Documents.Session.SessionDocument` if the session was updated correctly","ref":"Ravix.Documents.Session.SessionDocument.html#upsert_document/3-returns"},{"type":"type","title":"Ravix.Documents.Session.SessionDocument.t/0","doc":"","ref":"Ravix.Documents.Session.SessionDocument.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Session.State","doc":"A session state representation","ref":"Ravix.Documents.Session.State.html"},{"type":"module","title":"Fields - Ravix.Documents.Session.State","doc":"- store: The Store module for which the session belongs\n- session_id: The uuid of this session\n- database: for which database this session belongs\n- conventions: Document conventions for this session\n- documents_by_id: Loaded documents in this session\n- defer_commands: Commands that will be deferred when the session is persisted\n- deleted_entities: Documents that will be deleted when the session is persisted\n- running_queries: RQL queries running for this session\n- last_session_call: When the last session call was executed\n- number_of_requests: Number os requests that will be executed at this session persistence","ref":"Ravix.Documents.Session.State.html#module-fields"},{"type":"function","title":"Ravix.Documents.Session.State.clear_deferred_commands/1","doc":"Clear the deferred commands from the session","ref":"Ravix.Documents.Session.State.html#clear_deferred_commands/1"},{"type":"function","title":"Ravix.Documents.Session.State.clear_deleted_entities/1","doc":"Clear the deleted entities from the session","ref":"Ravix.Documents.Session.State.html#clear_deleted_entities/1"},{"type":"function","title":"Ravix.Documents.Session.State.clear_tmp_keys/1","doc":"","ref":"Ravix.Documents.Session.State.html#clear_tmp_keys/1"},{"type":"function","title":"Ravix.Documents.Session.State.fetch_document/2","doc":"Fetches a document from the session","ref":"Ravix.Documents.Session.State.html#fetch_document/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.State.fetch_document/2","doc":"- state: the session state\n- document_id: the document id","ref":"Ravix.Documents.Session.State.html#fetch_document/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.State.fetch_document/2","doc":"- `{:ok, document}`\n- `{:error, :document_not_found}` if there is no document with the informed id on the session","ref":"Ravix.Documents.Session.State.html#fetch_document/2-returns"},{"type":"function","title":"Ravix.Documents.Session.State.increment_request_count/1","doc":"Increments the number of requests count","ref":"Ravix.Documents.Session.State.html#increment_request_count/1"},{"type":"function","title":"Parameters - Ravix.Documents.Session.State.increment_request_count/1","doc":"- session_state: the session state","ref":"Ravix.Documents.Session.State.html#increment_request_count/1-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.State.increment_request_count/1","doc":"- updated session state","ref":"Ravix.Documents.Session.State.html#increment_request_count/1-returns"},{"type":"function","title":"Ravix.Documents.Session.State.mark_document_for_exclusion/2","doc":"Marks a document to be deleted","ref":"Ravix.Documents.Session.State.html#mark_document_for_exclusion/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.State.mark_document_for_exclusion/2","doc":"- state: the session state\n- document_id: the document id to be deleted","ref":"Ravix.Documents.Session.State.html#mark_document_for_exclusion/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.State.mark_document_for_exclusion/2","doc":"- `{:ok, state}`\n- `{:error, :document_already_deferred}` if the document id is in a deferred command\n- `{:error, :document_deleted}` if the document is already marked for delete\n- `{:error, :document_not_in_session}` is the document is not loaded in the session","ref":"Ravix.Documents.Session.State.html#mark_document_for_exclusion/2-returns"},{"type":"function","title":"Ravix.Documents.Session.State.register_document/5","doc":"Adds a document to the session","ref":"Ravix.Documents.Session.State.html#register_document/5"},{"type":"function","title":"Parameters - Ravix.Documents.Session.State.register_document/5","doc":"- state: the session state\n- key: the key where the document will be related to\n- entity: the document to be persisted\n- change_vector: the concurrency change vector string\n- original_document: if it's a update, this is the document before the change","ref":"Ravix.Documents.Session.State.html#register_document/5-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.State.register_document/5","doc":"- `{:ok, updated_state}`\n- `{:error, :document_already_deferred}` if the document id is in a deferred command\n- `{:error, :document_deleted}` if the document is marked for delete","ref":"Ravix.Documents.Session.State.html#register_document/5-returns"},{"type":"function","title":"Ravix.Documents.Session.State.update_last_session_call/1","doc":"Updates the last session call time","ref":"Ravix.Documents.Session.State.html#update_last_session_call/1"},{"type":"function","title":"Parameters - Ravix.Documents.Session.State.update_last_session_call/1","doc":"- session_state: the session state","ref":"Ravix.Documents.Session.State.html#update_last_session_call/1-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.State.update_last_session_call/1","doc":"- updated session state","ref":"Ravix.Documents.Session.State.html#update_last_session_call/1-returns"},{"type":"function","title":"Ravix.Documents.Session.State.update_session/2","doc":"Updates the session with RavenDB responses","ref":"Ravix.Documents.Session.State.html#update_session/2"},{"type":"function","title":"Parameters - Ravix.Documents.Session.State.update_session/2","doc":"- session_state: the session state\n- updates: List of updates to be applied to the session","ref":"Ravix.Documents.Session.State.html#update_session/2-parameters"},{"type":"function","title":"Returns - Ravix.Documents.Session.State.update_session/2","doc":"- the updated session","ref":"Ravix.Documents.Session.State.html#update_session/2-returns"},{"type":"type","title":"Ravix.Documents.Session.State.t/0","doc":"","ref":"Ravix.Documents.Session.State.html#t:t/0"},{"type":"module","title":"Ravix.Documents.Session.Supervisor","doc":"Supervisor for RavenDB Sessions","ref":"Ravix.Documents.Session.Supervisor.html"},{"type":"function","title":"Ravix.Documents.Session.Supervisor.close_session/2","doc":"Closes a session for the informed store using the session pid or session_id","ref":"Ravix.Documents.Session.Supervisor.html#close_session/2"},{"type":"function","title":"Ravix.Documents.Session.Supervisor.create_session/1","doc":"Creates a session with the informed initial state","ref":"Ravix.Documents.Session.Supervisor.html#create_session/1"},{"type":"function","title":"Ravix.Documents.Session.Supervisor.start_link/1","doc":"","ref":"Ravix.Documents.Session.Supervisor.html#start_link/1"},{"type":"module","title":"Ravix.Documents.Session.Validations","doc":"Validation rules for session states","ref":"Ravix.Documents.Session.Validations.html"},{"type":"function","title":"Ravix.Documents.Session.Validations.all_ids_are_not_already_loaded/2","doc":"Returns an error if all the informed ids are already loaded in the session","ref":"Ravix.Documents.Session.Validations.html#all_ids_are_not_already_loaded/2"},{"type":"function","title":"Ravix.Documents.Session.Validations.document_in_session?/2","doc":"Return an error if the document is not in the session","ref":"Ravix.Documents.Session.Validations.html#document_in_session?/2"},{"type":"function","title":"Ravix.Documents.Session.Validations.document_not_deleted/2","doc":"Returns an error if the document is already marked for deletion","ref":"Ravix.Documents.Session.Validations.html#document_not_deleted/2"},{"type":"function","title":"Ravix.Documents.Session.Validations.document_not_in_deferred_command/2","doc":"Returns an error if the document is in a deferred command","ref":"Ravix.Documents.Session.Validations.html#document_not_in_deferred_command/2"},{"type":"function","title":"Ravix.Documents.Session.Validations.document_not_stored/2","doc":"Returns an error if the document is already stored in the session","ref":"Ravix.Documents.Session.Validations.html#document_not_stored/2"},{"type":"function","title":"Ravix.Documents.Session.Validations.load_documents_limit_reached/2","doc":"","ref":"Ravix.Documents.Session.Validations.html#load_documents_limit_reached/2"},{"type":"function","title":"Ravix.Documents.Session.Validations.session_request_limit_reached/1","doc":"","ref":"Ravix.Documents.Session.Validations.html#session_request_limit_reached/1"},{"type":"behaviour","title":"Ravix.Documents.Store","doc":"Macro to define a RavenDB Repository Store","ref":"Ravix.Documents.Store.html"},{"type":"behaviour","title":"Example - Ravix.Documents.Store","doc":"`defmodule Ravix.TestRepo do\n       use Ravix.Documents.Store\n     end`","ref":"Ravix.Documents.Store.html#module-example"},{"type":"callback","title":"Ravix.Documents.Store.close_session/1","doc":"Closes a RavenDB local session\n\nReturns `:ok` if successful or `{:error, :not_found}` if the session\nis not found","ref":"Ravix.Documents.Store.html#c:close_session/1"},{"type":"callback","title":"Examples - Ravix.Documents.Store.close_session/1","doc":"iex> Ravix.Test.Store.close_session(\"8945c215-dd67-44da-9a64-2916e0a328d9\")\n    :ok","ref":"Ravix.Documents.Store.html#c:close_session/1-examples"},{"type":"callback","title":"Ravix.Documents.Store.open_session/0","doc":"Opens a RavenDB local session\n\nReturns a tuple with `{:ok, uuid}` if successful or `{:error, :not_found}` if the store\nis not initialized","ref":"Ravix.Documents.Store.html#c:open_session/0"},{"type":"callback","title":"Examples - Ravix.Documents.Store.open_session/0","doc":"iex> Ravix.Test.Store.open_session\n    {:ok, \"8945c215-dd67-44da-9a64-2916e0a328d9\"}","ref":"Ravix.Documents.Store.html#c:open_session/0-examples"},{"type":"callback","title":"Ravix.Documents.Store.start_link/1","doc":"","ref":"Ravix.Documents.Store.html#c:start_link/1"},{"type":"module","title":"Ravix.Helpers.Certs","doc":"Helper utility that reads PEM certificates in base64 into DER encoded structures","ref":"Ravix.Helpers.Certs.html"},{"type":"function","title":"Ravix.Helpers.Certs.cert_from_b64_to_der/1","doc":"","ref":"Ravix.Helpers.Certs.html#cert_from_b64_to_der/1"},{"type":"function","title":"Ravix.Helpers.Certs.key_from_b64_to_der/1","doc":"","ref":"Ravix.Helpers.Certs.html#key_from_b64_to_der/1"},{"type":"module","title":"Ravix.Helpers.UrlBuilder","doc":"Helper to facilitate building url query params following the RavenDB API","ref":"Ravix.Helpers.UrlBuilder.html"},{"type":"function","title":"Ravix.Helpers.UrlBuilder.append_param/3","doc":"Receives a base url, param name and a (list of) param value and parses it to \na valid RavenDB url","ref":"Ravix.Helpers.UrlBuilder.html#append_param/3"},{"type":"module","title":"Ravix.Operations.Database.Commands.CreateDatabaseCommand","doc":"Command to create a RavenDB database","ref":"Ravix.Operations.Database.Commands.CreateDatabaseCommand.html"},{"type":"module","title":"Fields - Ravix.Operations.Database.Commands.CreateDatabaseCommand","doc":"- Disabled: true/false - If the database is created disabled as default\n- Encrypted: true/false - If the database is encrypted as default\n- DatabaseName: Name - the database name\n- ReplicationFactor: int - the replication factor of the database","ref":"Ravix.Operations.Database.Commands.CreateDatabaseCommand.html#module-fields"},{"type":"type","title":"Ravix.Operations.Database.Commands.CreateDatabaseCommand.t/0","doc":"","ref":"Ravix.Operations.Database.Commands.CreateDatabaseCommand.html#t:t/0"},{"type":"module","title":"Ravix.Operations.Database.Commands.DeleteDatabaseCommand","doc":"Command to delete a RavenDB database","ref":"Ravix.Operations.Database.Commands.DeleteDatabaseCommand.html"},{"type":"type","title":"Ravix.Operations.Database.Commands.DeleteDatabaseCommand.t/0","doc":"","ref":"Ravix.Operations.Database.Commands.DeleteDatabaseCommand.html#t:t/0"},{"type":"module","title":"Ravix.Operations.Database.Commands.GetStatisticsCommand","doc":"Command to delete a RavenDB database","ref":"Ravix.Operations.Database.Commands.GetStatisticsCommand.html"},{"type":"type","title":"Ravix.Operations.Database.Commands.GetStatisticsCommand.t/0","doc":"","ref":"Ravix.Operations.Database.Commands.GetStatisticsCommand.html#t:t/0"},{"type":"module","title":"Ravix.Operations.Database.Maintenance","doc":"Database maintenance operations module","ref":"Ravix.Operations.Database.Maintenance.html"},{"type":"function","title":"Ravix.Operations.Database.Maintenance.create_database/2","doc":"Creates a database using the informed request executor\n\nOptions:\n- :encrypted = true/false\n- :disabled = true/false\n- :replication_factor = 1-N","ref":"Ravix.Operations.Database.Maintenance.html#create_database/2"},{"type":"function","title":"Examples - Ravix.Operations.Database.Maintenance.create_database/2","doc":"iex> Ravix.Operations.Database.Maintenance.create_database(Ravix.Test.Store, \"test_db\")\n    {:ok,\n    %{\n      \"Name\" => \"test_db\",\n      \"NodesAddedTo\" => [\"http://4e0373cbf5d0:8080\"],\n      \"RaftCommandIndex\" => 443,\n      \"Topology\" => %{\n        \"ClusterTransactionIdBase64\" => \"mdO7gPZsMEeslGOxxNfpjA\",\n        \"DatabaseTopologyIdBase64\" => \"0FHV8Uc0jEi94uZQiT00mA\",\n        \"DemotionReasons\" => %{},\n        \"DynamicNodesDistribution\" => false,\n        \"Members\" => [\"A\"],\n        \"NodesModifiedAt\" => \"2022-04-23T11:00:06.9470373Z\",\n        \"PriorityOrder\" => [],\n        \"Promotables\" => [],\n        \"PromotablesStatus\" => %{},\n        \"Rehabs\" => [],\n        \"ReplicationFactor\" => 1,\n        \"Stamp\" => %{\"Index\" => 443, \"LeadersTicks\" => -2, \"Term\" => 4}\n      }\n    }}","ref":"Ravix.Operations.Database.Maintenance.html#create_database/2-examples"},{"type":"function","title":"Ravix.Operations.Database.Maintenance.database_stats/2","doc":"","ref":"Ravix.Operations.Database.Maintenance.html#database_stats/2"},{"type":"function","title":"Ravix.Operations.Database.Maintenance.delete_database/2","doc":"","ref":"Ravix.Operations.Database.Maintenance.html#delete_database/2"},{"type":"module","title":"Ravix.RQL.Query","doc":"Detructurized Raven Query Language structure","ref":"Ravix.RQL.Query.html"},{"type":"function","title":"Ravix.RQL.Query.and?/2","doc":"Adds an `Ravix.RQL.Tokens.And` operation with a `Ravix.RQL.Tokens.Condition` to the query\n\nReturns a `Ravix.RQL.Query` with the and condition","ref":"Ravix.RQL.Query.html#and?/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.and?/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> where = Ravix.RQL.Query.where(from, equal_to(\"cat_name\", \"Meowvius\"))\n    iex> and_v = Ravix.RQL.Query.and?(where, equal_to(\"breed\", \"Fatto\"))","ref":"Ravix.RQL.Query.html#and?/2-examples"},{"type":"function","title":"Ravix.RQL.Query.and_not/2","doc":"Adds an negated `Ravix.RQL.Tokens.And` operation with a `Ravix.RQL.Tokens.Condition` to the query\n\nReturns a `Ravix.RQL.Query` with the and condition","ref":"Ravix.RQL.Query.html#and_not/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.and_not/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> where = Ravix.RQL.Query.where(from, equal_to(\"cat_name\", \"Meowvius\"))\n    iex> and_v = Ravix.RQL.Query.and_not(where, equal_to(\"breed\", \"Fatto\"))","ref":"Ravix.RQL.Query.html#and_not/2-examples"},{"type":"function","title":"Ravix.RQL.Query.delete_for/2","doc":"Executes the delete query in the informed session\n\nReturns a [RavenDB response](https://ravendb.net/docs/article-page/5.3/java/client-api/rest-api/queries/delete-by-query#response-format) map","ref":"Ravix.RQL.Query.html#delete_for/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.delete_for/2","doc":"iex> from(\"@all_docs\")\n          |> where(equal_to(\"cat_name\", any_entity.cat_name))\n          |> delete_for(session_id)\n        {:ok, %{\"OperationId\" => 2480, \"OperationNodeTag\" => \"A\"}}","ref":"Ravix.RQL.Query.html#delete_for/2-examples"},{"type":"function","title":"Ravix.RQL.Query.from/1","doc":"Creates a new query for the informed collection or index\n\nReturns a `Ravix.RQL.Query` or an `{:error, :query_document_must_be_informed}` if no collection/index was informed","ref":"Ravix.RQL.Query.html#from/1"},{"type":"function","title":"Examples - Ravix.RQL.Query.from/1","doc":"iex> Ravix.RQL.Query.from(\"test\")","ref":"Ravix.RQL.Query.html#from/1-examples"},{"type":"function","title":"Ravix.RQL.Query.from/2","doc":"Creates a new query with an alias for the informed collection or index\n\nReturns a `Ravix.RQL.Query` or an `{:error, :query_document_must_be_informed}` if no collection/index was informed","ref":"Ravix.RQL.Query.html#from/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.from/2","doc":"iex> Ravix.RQL.Query.from(\"test\", \"t\")","ref":"Ravix.RQL.Query.html#from/2-examples"},{"type":"function","title":"Ravix.RQL.Query.group_by/2","doc":"Adds a `Ravix.RQL.Tokens.Group` operation to the query\n\nReturns a `Ravix.RQL.Query` with the group_by condition","ref":"Ravix.RQL.Query.html#group_by/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.group_by/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> grouped = Ravix.RQL.Query.group_by(from, \"breed\")","ref":"Ravix.RQL.Query.html#group_by/2-examples"},{"type":"function","title":"Ravix.RQL.Query.limit/3","doc":"Adds a `Ravix.RQL.Tokens.Limit` operation to the query\n\nReturns a `Ravix.RQL.Query` with the limit condition","ref":"Ravix.RQL.Query.html#limit/3"},{"type":"function","title":"Examples - Ravix.RQL.Query.limit/3","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> limit = Ravix.RQL.Query.limit(from, 5, 10)","ref":"Ravix.RQL.Query.html#limit/3-examples"},{"type":"function","title":"Ravix.RQL.Query.list_all/2","doc":"Executes the query in the informed session and returns the matched documents\n\nReturns a [RavenDB response](https://ravendb.net/docs/article-page/4.2/java/client-api/rest-api/queries/query-the-database#response-format) map","ref":"Ravix.RQL.Query.html#list_all/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.list_all/2","doc":"iex> from(\"Cats\")\n          |> select(\"name\")\n          |> where(equal_to(\"name\", cat.name))\n          |> list_all(session_id)\n        {:ok, %{\n            \"DurationInMs\" => 62,\n            \"IncludedPaths\" => nil,\n            \"Includes\" => %{},\n            \"IndexName\" => \"Auto/Cats/By@metadata.@last-modifiedAndidAndname\",\n            \"IndexTimestamp\" => \"2022-04-22T20:03:03.8373804\",\n            \"IsStale\" => false,\n            \"LastQueryTime\" => \"2022-04-22T20:03:04.3475275\",\n            \"LongTotalResults\" => 1,\n            \"NodeTag\" => \"A\",\n            \"ResultEtag\" => 6489530344045176783,\n            \"Results\" => [\n              %{\n                \"@metadata\" => %{\n                  \"@change-vector\" => \"A:6445-HJrwf2z3c0G/FHJPm3zK3w\",\n                  \"@id\" => \"beee79e2-2560-408c-a680-253e9bd7d12e\",\n                  \"@index-score\" => 3.079441547393799,\n                  \"@last-modified\" => \"2022-04-22T20:03:03.7477980Z\",\n                  \"@projection\" => true\n                },\n                \"name\" => \"Lily\"\n              }\n            ],\n            \"ScannedResults\" => 0,\n            \"SkippedResults\" => 0,\n            \"TotalResults\" => 1\n          }\n        }","ref":"Ravix.RQL.Query.html#list_all/2-examples"},{"type":"function","title":"Ravix.RQL.Query.or?/2","doc":"Adds an `Ravix.RQL.Tokens.Or` operation with a `Ravix.RQL.Tokens.Condition` to the query\n\nReturns a `Ravix.RQL.Query` with the and condition","ref":"Ravix.RQL.Query.html#or?/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.or?/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> where = Ravix.RQL.Query.where(from, equal_to(\"cat_name\", \"Meowvius\"))\n    iex> or_v = Ravix.RQL.Query.or?(where, equal_to(\"breed\", \"Fatto\"))","ref":"Ravix.RQL.Query.html#or?/2-examples"},{"type":"function","title":"Ravix.RQL.Query.or_not/2","doc":"Adds a negated `Ravix.RQL.Tokens.Or` operation with a `Ravix.RQL.Tokens.Condition` to the query\n\nReturns a `Ravix.RQL.Query` with the and condition","ref":"Ravix.RQL.Query.html#or_not/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.or_not/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> where = Ravix.RQL.Query.where(from, equal_to(\"cat_name\", \"Meowvius\"))\n    iex> or_v = Ravix.RQL.Query.or_not(where, equal_to(\"breed\", \"Fatto\"))","ref":"Ravix.RQL.Query.html#or_not/2-examples"},{"type":"function","title":"Ravix.RQL.Query.order_by/2","doc":"Adds a `Ravix.RQL.Tokens.Order` operation to the query\n\nReturns a `Ravix.RQL.Query` with the ordering condition","ref":"Ravix.RQL.Query.html#order_by/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.order_by/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> ordered = Ravix.RQL.Query.order_by(from, [%Order.Field{name: \"@metadata.@last-modified\", order: :desc, type: :number}])","ref":"Ravix.RQL.Query.html#order_by/2-examples"},{"type":"function","title":"Ravix.RQL.Query.raw/1","doc":"Create a Query using a raw RQL string\n\nReturns a `Ravix.RQL.Query` with the raw query","ref":"Ravix.RQL.Query.html#raw/1"},{"type":"function","title":"Examples - Ravix.RQL.Query.raw/1","doc":"iex> raw = Ravix.RQL.Query.raw(\"from @all_docs where cat_name = \"Fluffers\"\")","ref":"Ravix.RQL.Query.html#raw/1-examples"},{"type":"function","title":"Ravix.RQL.Query.raw/2","doc":"Create a Query using a raw RQL string with replaceable placeholders\n\nReturns a `Ravix.RQL.Query` with the raw query and parameters","ref":"Ravix.RQL.Query.html#raw/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.raw/2","doc":"iex> raw = Ravix.RQL.Query.raw(\"from @all_docs where cat_name = $p1\", %{p1: \"Fluffers\"})","ref":"Ravix.RQL.Query.html#raw/2-examples"},{"type":"function","title":"Ravix.RQL.Query.select/2","doc":"Adds a select operation to project fields\n\nReturns a `Ravix.RQL.Query` with the select condition","ref":"Ravix.RQL.Query.html#select/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.select/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> select = Ravix.RQL.Query.select(from, [\"name\", \"breed\"])","ref":"Ravix.RQL.Query.html#select/2-examples"},{"type":"function","title":"Ravix.RQL.Query.select_function/2","doc":"Adds a select operation to project fields, leveraging the use of RavenDB Functions\n\nReturns a `Ravix.RQL.Query` with the select condition","ref":"Ravix.RQL.Query.html#select_function/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.select_function/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> select = Ravix.RQL.Query.select_function(from, ooga: \"c.name\")","ref":"Ravix.RQL.Query.html#select_function/2-examples"},{"type":"function","title":"Ravix.RQL.Query.stream_all/2","doc":"Executes the query in the informed session and returns the matched documents\n\nReturns a [RavenDB response](https://ravendb.net/docs/article-page/4.2/java/client-api/rest-api/queries/query-the-database#response-format) map","ref":"Ravix.RQL.Query.html#stream_all/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.stream_all/2","doc":"iex> stream = from(\"Cats\")\n          |> select(\"name\")\n          |> where(equal_to(\"name\", cat.name))\n          |> stream_all(session_id)\n\n        stream |> Enum.to_list()\n        [\n            %{\n              \"@metadata\" => %{\n              \"@change-vector\" => \"A:6445-HJrwf2z3c0G/FHJPm3zK3w\",\n              \"@id\" => \"beee79e2-2560-408c-a680-253e9bd7d12e\",\n              \"@index-score\" => 3.079441547393799,\n              \"@last-modified\" => \"2022-04-22T20:03:03.7477980Z\",\n              \"@projection\" => true\n            },\n            \"name\" => \"Lily\"\n          }\n        ]","ref":"Ravix.RQL.Query.html#stream_all/2-examples"},{"type":"function","title":"Ravix.RQL.Query.update/2","doc":"Adds an update operation to the informed query, it supports a\n`Ravix.RQL.Tokens.Update` token. The token can be created using the following functions:\n\n`Ravix.RQL.Tokens.Update.set(%Update{}, field, new_value)` to set values\n`Ravix.RQL.Tokens.Update.inc(%Update{}, field, value_to_inc)` to inc values\n`Ravix.RQL.Tokens.Update.dec(%Update{}, field, value_to_dec)` to dec values\n\nReturns a `Ravix.RQL.Query` with the update operation","ref":"Ravix.RQL.Query.html#update/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.update/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> update = Ravix.RQL.Query.update(from, set(%Update{}, :cat_name, \"Fluffer, the hand-ripper\"))","ref":"Ravix.RQL.Query.html#update/2-examples"},{"type":"function","title":"Ravix.RQL.Query.update_for/2","doc":"Executes the patch query in the informed session\n\nReturns a [RavenDB response](https://ravendb.net/docs/article-page/5.3/java/client-api/rest-api/queries/patch-by-query#response-format) map","ref":"Ravix.RQL.Query.html#update_for/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.update_for/2","doc":"iex> from(\"@all_docs\", \"a\")\n          |> update(set(%Update{}, :cat_name, \"Fluffer, the hand-ripper\"))\n          |> where(equal_to(\"cat_name\", any_entity.cat_name))\n          |> update_for(session_id)\n        {:ok, %{\"OperationId\" => 2480, \"OperationNodeTag\" => \"A\"}}","ref":"Ravix.RQL.Query.html#update_for/2-examples"},{"type":"function","title":"Ravix.RQL.Query.where/2","doc":"Adds a where operation with a `Ravix.RQL.Tokens.Condition` to the query\n\nReturns a `Ravix.RQL.Query` with the where condition","ref":"Ravix.RQL.Query.html#where/2"},{"type":"function","title":"Examples - Ravix.RQL.Query.where/2","doc":"iex> from = Ravix.RQL.Query.from(\"cats\", \"c\")\n    iex> where = Ravix.RQL.Query.where(from, equal_to(\"cat_name\", \"Meowvius\"))","ref":"Ravix.RQL.Query.html#where/2-examples"},{"type":"type","title":"Ravix.RQL.Query.t/0","doc":"","ref":"Ravix.RQL.Query.html#t:t/0"},{"type":"module","title":"Ravix.RQL.Tokens.Condition","doc":"Supported RQL Conditions","ref":"Ravix.RQL.Tokens.Condition.html"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.between/2","doc":"Specifies that the value is between two values\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#between/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.between/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> between(\"field\", [15,25])","ref":"Ravix.RQL.Tokens.Condition.html#between/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.equal_to/2","doc":"Equal to condition\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#equal_to/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.equal_to/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> equal_to(\"field\", \"value\")","ref":"Ravix.RQL.Tokens.Condition.html#equal_to/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.greater_than/2","doc":"Greater than condition\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#greater_than/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.greater_than/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> greater_than(\"field\", 10)","ref":"Ravix.RQL.Tokens.Condition.html#greater_than/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.greater_than_or_equal_to/2","doc":"Greater than or equal to condition\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#greater_than_or_equal_to/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.greater_than_or_equal_to/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> greater_than_or_equal_to(\"field\", 10)","ref":"Ravix.RQL.Tokens.Condition.html#greater_than_or_equal_to/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.in?/2","doc":"Specifies that the value is in a list\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#in?/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.in?/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> in?(\"field\", [1,2,3])","ref":"Ravix.RQL.Tokens.Condition.html#in?/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.lower_than/2","doc":"Lower than condition\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#lower_than/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.lower_than/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> lower_than(\"field\", 10)","ref":"Ravix.RQL.Tokens.Condition.html#lower_than/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.lower_than_or_equal_to/2","doc":"Lower than or equal to condition\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#lower_than_or_equal_to/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.lower_than_or_equal_to/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> lower_than_or_equal_to(\"field\", 10)","ref":"Ravix.RQL.Tokens.Condition.html#lower_than_or_equal_to/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.not_equal_to/2","doc":"Not Equal to condition\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#not_equal_to/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.not_equal_to/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> not_equal_to(\"field\", \"value\")","ref":"Ravix.RQL.Tokens.Condition.html#not_equal_to/2-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Condition.not_in/2","doc":"Specifies that the value is not in a list\n\nReturns a `Ravix.RQL.Tokens.Condition`","ref":"Ravix.RQL.Tokens.Condition.html#not_in/2"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Condition.not_in/2","doc":"iex> import Ravix.RQL.Tokens.Condition\n    iex> not_in(\"field\", [\"a\", \"b\", \"c\"])","ref":"Ravix.RQL.Tokens.Condition.html#not_in/2-examples"},{"type":"type","title":"Ravix.RQL.Tokens.Condition.t/0","doc":"","ref":"Ravix.RQL.Tokens.Condition.html#t:t/0"},{"type":"module","title":"Ravix.RQL.Tokens.Update","doc":"RQL Update tokens","ref":"Ravix.RQL.Tokens.Update.html"},{"type":"function","title":"Ravix.RQL.Tokens.Update.dec/3","doc":"Creates a new \"decrement\" update operation\n\nReturns a `Ravix.RQL.Tokens.Update`","ref":"Ravix.RQL.Tokens.Update.html#dec/3"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Update.dec/3","doc":"iex> import alias Ravix.RQL.Tokens.Update\n    iex> dec(\"field1\", 10)","ref":"Ravix.RQL.Tokens.Update.html#dec/3-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Update.inc/3","doc":"Creates a new \"increment\" update operation\n\nReturns a `Ravix.RQL.Tokens.Update`","ref":"Ravix.RQL.Tokens.Update.html#inc/3"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Update.inc/3","doc":"iex> import alias Ravix.RQL.Tokens.Update\n    iex> inc(\"field1\", 10)","ref":"Ravix.RQL.Tokens.Update.html#inc/3-examples"},{"type":"function","title":"Ravix.RQL.Tokens.Update.set/3","doc":"Creates a new \"set\" update operation\n\nReturns a `Ravix.RQL.Tokens.Update`","ref":"Ravix.RQL.Tokens.Update.html#set/3"},{"type":"function","title":"Examples - Ravix.RQL.Tokens.Update.set/3","doc":"iex> import alias Ravix.RQL.Tokens.Update\n    iex> set(\"field1\", 10) |> set(\"field2\", \"a\")","ref":"Ravix.RQL.Tokens.Update.html#set/3-examples"},{"type":"type","title":"Ravix.RQL.Tokens.Update.t/0","doc":"","ref":"Ravix.RQL.Tokens.Update.html#t:t/0"},{"type":"module","title":"Ravix.Telemetry","doc":"Telemetry events supported by the Ravix Driver\n\n   All the events follow the [:ravix, store_atom] prefix\n\n   In addition to the specific Ravix events, all the Tesla events\n   are also propagated","ref":"Ravix.Telemetry.html"},{"type":"function","title":"Ravix.Telemetry.node_selected/1","doc":"Fires when a node is selected, can be filtered by the node url","ref":"Ravix.Telemetry.html#node_selected/1"},{"type":"function","title":"Ravix.Telemetry.query_executed/1","doc":"Fires when a query is executed","ref":"Ravix.Telemetry.html#query_executed/1"},{"type":"function","title":"Ravix.Telemetry.request_error/2","doc":"Fires when a request ends in error, can be filtered by node url or status","ref":"Ravix.Telemetry.html#request_error/2"},{"type":"function","title":"Ravix.Telemetry.request_stale/2","doc":"Fires when there's a request to a stale index, can be filtered by the node url or index name","ref":"Ravix.Telemetry.html#request_stale/2"},{"type":"function","title":"Ravix.Telemetry.request_success/1","doc":"Fires when a request ends successfully","ref":"Ravix.Telemetry.html#request_success/1"},{"type":"function","title":"Ravix.Telemetry.retry_count/2","doc":"Fires when a retry is requested, can be filtered by the node url or http status","ref":"Ravix.Telemetry.html#retry_count/2"},{"type":"function","title":"Ravix.Telemetry.session_ended/1","doc":"Fires when a session is ended","ref":"Ravix.Telemetry.html#session_ended/1"},{"type":"function","title":"Ravix.Telemetry.session_started/1","doc":"Fires when a session is started","ref":"Ravix.Telemetry.html#session_started/1"},{"type":"function","title":"Ravix.Telemetry.session_timed_out/1","doc":"Fires when a session times-out","ref":"Ravix.Telemetry.html#session_timed_out/1"},{"type":"function","title":"Ravix.Telemetry.topology_updated/1","doc":"Fires when a topology request is requested","ref":"Ravix.Telemetry.html#topology_updated/1"},{"type":"exception","title":"Ravix.Connection.RequestExecutor.Errors.MaximumUrlLengthError","doc":"","ref":"Ravix.Connection.RequestExecutor.Errors.MaximumUrlLengthError.html"},{"type":"extras","title":"README","doc":"![ravix_logo](https://user-images.githubusercontent.com/1266053/148282743-79994640-4b15-4ffb-b477-5d0ed18072f9.png)\n\n[![Elixir CI](https://github.com/YgorCastor/ravix/actions/workflows/elixir.yml/badge.svg)](https://github.com/YgorCastor/ravix/actions/workflows/elixir.yml) [![Coverage Status](https://coveralls.io/repos/github/YgorCastor/ravix/badge.svg)](https://coveralls.io/github/YgorCastor/ravix)\n[![Hex](https://img.shields.io/hexpm/v/ravix?style=flat-square)](https://hex.pm/packages/ravix)\n\n\n# Ravix\n\nRavix is a in-development project to implement a client for the amazing [RavenDB NoSQL Database](https://ravendb.net/).\n\n# Usage","ref":"readme.html"},{"type":"extras","title":"Installing - README","doc":"Add Ravix to your mix.exs dependencies\n\n```elixir\n{:ravix, \"~> 0.10.0\"}\n```","ref":"readme.html#installing"},{"type":"extras","title":"Setting up your Repository - README","doc":"Create a Ravix Store Module for your repository\n\n```elixir\ndefmodule YourProject.YourStore do\n  use Ravix.Documents.Store, otp_app: :your_app\nend\n```\n\nYou can configure your Store in your config.exs files\n\n```elixir\nconfig :ravix, Ravix.Test.Store,\n  urls: [System.get_env(\"RAVENDB_URL\", \"http://localhost:8080\")],\n  database: \"test\",\n  retry_on_failure: true,\n  retry_backoff: 100,\n  retry_count: 3,\n  force_create_database: true,\n  document_conventions: %{\n    max_number_of_requests_per_session: 30,\n    max_ids_to_catch: 32,\n    timeout: 30,\n    use_optimistic_concurrency: false,\n    max_length_of_query_using_get_url: 1024 + 512,\n    identity_parts_separator: \"/\",\n    disable_topology_update: false\n  }\n```\n\nNote: All the calls to RavenDB are done via HTTP calls, to that we leverage the use of [Finch](https://github.com/sneako/finch), check there for adapter configurations.\n\nThen you can start the processes in your main supervisor\n\n```elixir\ndefmodule Ravix.TestApplication do\n  use Application\n\n  def start(_opts, _) do\n    children = [\n      {Finch, name: Ravix.Finch}, # By default the store searches for a Finch instance called 'Ravix.Finch' \n      {Ravix.Test.Store, [%{}]} # you can create multiple stores\n    ]\n\n    Supervisor.init(\n      children,\n      strategy: :one_for_one\n    )\n  end\nend\n```","ref":"readme.html#setting-up-your-repository"},{"type":"extras","title":"Querying the Database - README","doc":"All operations supported by the driver should be executed inside a session, to open a session you can just call the `open_session/0` function from the store you defined. All the changes are only persisted when the function \n`Ravix.Documents.Session.save_changes/1` is called!\n\n```elixir\niex(2)> Ravix.Test.Store.open_session()\n{:ok, \"985781c8-9154-494b-92d0-a66b49bb17ee\"}\n```\n\n#","ref":"readme.html#querying-the-database"},{"type":"extras","title":"Inserting a new document - README","doc":"```elixir\niex(2)> Ravix.Test.Store.open_session()\niex(2)> {:ok, session_id} = Ravix.Test.Store.open_session()\n{:ok, \"c4fb1f48-c969-4c76-9b12-5521926c7533\"}\niex(3)> Ravix.Documents.Session.store(session_id, %{id: \"cat/1\", cat_name: \"Adolfus\"})\n{:ok, %{cat_name: \"Adolfus\", id: \"cat/1\"}}\niex(4)> Ravix.Documents.Session.save_changes(session_id)\n{:ok,\n %{\n   \"Results\" => [\n     %{\n       \"@change-vector\" => \"A:264-vzsRp+yZT0GDkS5GJY/pAQ\",\n       \"@collection\" => \"@empty\",\n       \"@id\" => \"cat/1\",\n       \"@last-modified\" => \"2022-03-28T15:01:45.6545514Z\",\n       \"Type\" => \"PUT\"\n     }\n   ]\n }}\n```\n\n#","ref":"readme.html#inserting-a-new-document"},{"type":"extras","title":"Loading a document into the session - README","doc":"```elixir\niex(3)> {:ok, session_id} = Ravix.Test.Store.open_session()\n{:ok, \"d17e2be8-8c1e-4a59-8626-46725387f769\"}\niex(4)> Ravix.Documents.Session.load(session_id, [\"cat/1\"])\n{:ok,\n %{\n   \"Includes\" => %{},\n   \"Results\" => [\n     %{\n       \"@metadata\" => %{\n         \"@change-vector\" => \"A:264-vzsRp+yZT0GDkS5GJY/pAQ\",\n         \"@id\" => \"cat/1\",\n         \"@last-modified\" => \"2022-03-28T15:01:45.6545514Z\"\n       },\n       \"cat_name\" => \"Adolfus\",\n       \"id\" => \"cat/1\"\n     }\n   ],\n   \"already_loaded_ids\" => []\n }}\n```\n\n#","ref":"readme.html#loading-a-document-into-the-session"},{"type":"extras","title":"Querying using RQL - README","doc":"RavenDB provides a query-language called [RQL](https://ravendb.net/docs/article-page/4.2/csharp/indexes/querying/what-is-rql), and for that Ravix provides two ways to deal with queries, using builder functions and raw RQLs\n\n##","ref":"readme.html#querying-using-rql"},{"type":"extras","title":"RQL Builder - README","doc":"You can build RQLs using the builder provided by the `Ravix.RQL.Query` module\n\n```elixir\niex(11)> from(\"@all_docs\") |> where(equal_to(\"cat_name\", \"Adolfus\")) |> list_all(session_id)\n{:ok,\n %{\n   \"DurationInMs\" => 1,\n   \"IncludedPaths\" => nil,\n   \"Includes\" => %{},\n   \"IndexName\" => \"Auto/AllDocs/Bycat_nameAndid\",\n   \"IndexTimestamp\" => \"2022-03-28T18:39:58.7637789\",\n   \"IsStale\" => false,\n   \"LastQueryTime\" => \"2022-03-28T18:49:05.9272430\",\n   \"LongTotalResults\" => 1,\n   \"NodeTag\" => \"A\",\n   \"ResultEtag\" => -4402181509807245325,\n   \"Results\" => [\n     %{\n       \"@metadata\" => %{\n         \"@change-vector\" => \"A:264-vzsRp+yZT0GDkS5GJY/pAQ\",\n         \"@id\" => \"cat/1\",\n         \"@index-score\" => 5.330733299255371,\n         \"@last-modified\" => \"2022-03-28T15:01:45.6545514Z\"\n       },\n       \"cat_name\" => \"Adolfus\",\n       \"id\" => \"cat/1\"\n     }\n   ],\n   \"SkippedResults\" => 0,\n   \"TotalResults\" => 1\n }}\n```\n\n##","ref":"readme.html#rql-builder"},{"type":"extras","title":"Raw Query - README","doc":"```elixir\niex(13)> raw(\"from @all_docs where cat_name = \\\"Adolfus\\\"\") |> list_all(session_id)\n{:ok,\n %{\n   \"DurationInMs\" => 1,\n   \"IncludedPaths\" => nil,\n   \"Includes\" => %{},\n   \"IndexName\" => \"Auto/AllDocs/Bycat_nameAndid\",\n   \"IndexTimestamp\" => \"2022-03-28T18:39:58.7637789\",\n   \"IsStale\" => false,\n   \"LastQueryTime\" => \"2022-03-28T18:53:27.4689173\",\n   \"LongTotalResults\" => 1,\n   \"NodeTag\" => \"A\",\n   \"ResultEtag\" => -4402181509807245325,\n   \"Results\" => [\n     %{\n       \"@metadata\" => %{\n         \"@change-vector\" => \"A:264-vzsRp+yZT0GDkS5GJY/pAQ\",\n         \"@id\" => \"cat/1\",\n         \"@index-score\" => 5.330733299255371,\n         \"@last-modified\" => \"2022-03-28T15:01:45.6545514Z\"\n       },\n       \"cat_name\" => \"Adolfus\",\n       \"id\" => \"cat/1\"\n     }\n   ],\n   \"SkippedResults\" => 0,\n   \"TotalResults\" => 1\n }}\n```\n\n#","ref":"readme.html#raw-query"},{"type":"extras","title":"Collections - README","doc":"RavenDB can organize the documents in collections, Ravix will automatically insert the document in a collection if you use the Ravix. Document macro. If you don't want to use the macro, your struct just need to have the `:@metadata` field.\n\n```elixir\ndefmodule Ravix.SampleModel.Cat do\n  use Ravix.Document, fields: [:id, :name, :breed]\nend\n```","ref":"readme.html#collections"},{"type":"extras","title":"Secure Server - README","doc":"To connect to a secure server, you can just inform the SSL certificates based on the [erlang ssl configs](https://www.erlang.org/doc/man/ssl.html) to Finch itself.\n\nE.g:\n\n```elixir\n{Finch, name: Ravix.Finch,\n    pools: %{\n      default: [\n        conn_opts: [\n          transport_opts: [\n            cert: DER_CERT,\n            key: DER_KEY\n          ]\n        ]\n      ]\n    }\n},\n```","ref":"readme.html#secure-server"},{"type":"extras","title":"Ecto - README","doc":"What about querying your RavenDB using Ecto? [Ravix-Ecto](https://github.com/YgorCastor/ravix-ecto)","ref":"readme.html#ecto"},{"type":"extras","title":"Current State - README","doc":"* ~~Configuration Reading~~\n* ~~Session Management~~\n* ~~Request Executors~~\n* ~~Unsafe Server Connection~~\n* ~~Authenticated Server Connection~~\n* ~~Create Document~~\n* ~~Delete Document~~\n* ~~Load Document~~\n* ~~Queries Engine~~\n* ~~Clustering~~\n* ~~Topology Updates~~\n* Counters\n* Timeseries\n* Asynchronous Subscriptions\n* Attachments\n\nThe driver is working for the basic operations, clustering and resiliency are also implemented.","ref":"readme.html#current-state"}],"content_type":"text/markdown"}